
SCM Creator (+Github) - Bug #2102

Code to strip '.git' extensions is not correct.

27 Sep 2012 08:21 - Martin Corino

Status: Closed Start date: 27 Sep 2012

Priority: Normal Due date: 14 Nov 2012

Assignee: Andriy Lesyuk % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 0.4.2   

Redmine version: 2.1.0 External issue:  

Description

The code (regular expression) to strip the '.git’ extension from repository paths is not correct. It now also strips anything that ends

with any character followed by 'git’.

This is the result of constructing a regular expression from a string and forgetting the rule that in a string to get an escape character

you have to escape that escape, i.e. “\\”.

Below the patch I made to fix this.

diff --git a/plugins/redmine_scm/lib/creator/git_creator.rb b/plugins/redmine_scm/lib/creator/git_

creator.rb

index 14148ce..f50c150 100644

--- a/plugins/redmine_scm/lib/creator/git_creator.rb

+++ b/plugins/redmine_scm/lib/creator/git_creator.rb

@@ -36,7 +36,7 @@ class GitCreator < SCMCreator

         def repository_name(path)

             base = Redmine::Platform.mswin? ? options['path'].gsub(%r{\\}, "/") : options['path']

-            matches = Regexp.new("^#{Regexp.escape(base)}/([^/]+?)(\.git)?/?$").match(path)

+            matches = Regexp.new("^#{Regexp.escape(base)}/([^/]+?)(\\.git)?/?$").match(path)

             matches ? matches[1] : nil

         end

Related issues:

Related to SCM Creator (+Github) - Patch #2095: Git repositories are always c... Closed 24 Jul 2012 14 Nov 2012

Associated revisions

Revision 119 - 15 Nov 2012 00:08 - Andriy Lesyuk

Applied fixes (#2095, #2102 and #2120)

History

#1 - 27 Sep 2012 08:54 - Andriy Lesyuk

- Status changed from New to Open

- Assignee set to Andriy Lesyuk

Thanks for the patch!

#2 - 08 Oct 2012 14:17 - Andriy Lesyuk

- Target version set to 0.4.2

#3 - 14 Nov 2012 21:54 - Andriy Lesyuk

- Due date set to 14 Nov 2012

- Status changed from Open to Closed

- % Done changed from 0 to 100
Not yet committed...
